Bug 1634029 - Move Automate code for conversion hosts to backend
Summary: Move Automate code for conversion hosts to backend
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat CloudForms Management Engine
Classification: Red Hat
Component: V2V
Version: 5.9.4
Hardware: Unspecified
OS: Unspecified
medium
medium
Target Milestone: GA
: 5.10.0
Assignee: Fabien Dupont
QA Contact: Kedar Kulkarni
Red Hat CloudForms Documentation
URL:
Whiteboard:
Depends On:
Blocks: 1632355 1633526
TreeView+ depends on / blocked
 
Reported: 2018-09-28 13:31 UTC by Fabien Dupont
Modified: 2019-02-07 23:03 UTC (History)
4 users (show)

Fixed In Version: 5.10.0.21
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-02-07 23:03:43 UTC
Category: ---
Cloudforms Team: V2V
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2019:0212 None None None 2019-02-07 23:03:52 UTC

Description Fabien Dupont 2018-09-28 13:31:27 UTC
When developing initial code for V2V, the conversion host object didn't exist, so an implementation was made in Automate to interact with oVirt hosts. Now that the ConversionHost class has been implemented, it would be better to move that code into the ConversionHost class.

Some methods will also have to be exposed in Automate Model.

Comment 2 Fabien Dupont 2018-09-28 15:07:59 UTC
https://github.com/ManageIQ/manageiq/pull/18033

Comment 3 Fabien Dupont 2018-10-01 13:53:39 UTC
https://github.com/ManageIQ/manageiq-schema/pull/281

Comment 4 Fabien Dupont 2018-10-03 06:52:41 UTC
https://github.com/ManageIQ/manageiq-schema/pull/284

Comment 5 CFME Bot 2018-10-03 14:24:56 UTC
New commits detected on ManageIQ/manageiq-schema/hammer:

https://github.com/ManageIQ/manageiq-schema/commit/58bd0c05dd61a8f5597f9d49f1e4fedb39cb88ec
commit 58bd0c05dd61a8f5597f9d49f1e4fedb39cb88ec
Author:     Nick Carboni <ncarboni@redhat.com>
AuthorDate: Tue Oct  2 14:02:07 2018 -0400
Commit:     Nick Carboni <ncarboni@redhat.com>
CommitDate: Tue Oct  2 14:02:07 2018 -0400

    Merge pull request #281 from fdupont-redhat/v2v_add_conversion_host_id_to_transformation_task

    Add conversion_host_id to miq_request_task

    (cherry picked from commit eb7e077f462b9ab5e1c652f8220a34d22e4c8633)

    https://bugzilla.redhat.com/show_bug.cgi?id=1634029

 db/migrate/20181001131632_add_conversion_host_id_to_miq_request_tasks.rb | 46 +
 spec/migrations/20181001131632_add_conversion_host_id_to_miq_request_tasks_spec.rb | 58 +
 2 files changed, 104 insertions(+)


https://github.com/ManageIQ/manageiq-schema/commit/f5006a3ab6f3e1e5f4820f074a75415ea4b37110
commit f5006a3ab6f3e1e5f4820f074a75415ea4b37110
Author:     Brandon Dunne <brandondunne@hotmail.com>
AuthorDate: Tue Oct  2 23:44:40 2018 -0400
Commit:     Brandon Dunne <brandondunne@hotmail.com>
CommitDate: Tue Oct  2 23:44:40 2018 -0400

    Merge pull request #284 from agrare/fix_conversion_host_resource_type

    Fix invalid conversion host resource type

    (cherry picked from commit 2ce3c9a7bdf20ebe2541749e28d7d63eb92e9f71)

    https://bugzilla.redhat.com/show_bug.cgi?id=1634029

 db/migrate/20181001131632_add_conversion_host_id_to_miq_request_tasks.rb | 15 +-
 db/migrate/20181002192054_fix_conversion_host_resource_type.rb | 14 +
 spec/migrations/20181002192054_fix_conversion_host_resource_type_spec.rb | 44 +
 3 files changed, 68 insertions(+), 5 deletions(-)

Comment 6 CFME Bot 2018-10-05 16:01:18 UTC
New commit detected on ManageIQ/manageiq/hammer:

https://github.com/ManageIQ/manageiq/commit/7853eb4e5c305948b29e504e978a26660eebec1e
commit 7853eb4e5c305948b29e504e978a26660eebec1e
Author:     Adam Grare <agrare@redhat.com>
AuthorDate: Fri Oct  5 08:54:57 2018 -0400
Commit:     Adam Grare <agrare@redhat.com>
CommitDate: Fri Oct  5 08:54:57 2018 -0400

    Merge pull request #18033 from fdupont-redhat/conversion_host_backport_from_automate

    Add methods to conversion_host to build virt-v2v wrapper options

    (cherry picked from commit fcd7161de1680821293abba4e3c3418f95d37b5b)

    https://bugzilla.redhat.com/show_bug.cgi?id=1634029

 app/models/conversion_host.rb | 37 +
 app/models/service_template_transformation_plan_task.rb | 143 +-
 config/settings.yml | 4 +-
 spec/models/conversion_host_spec.rb | 101 +
 spec/models/service_template_transformation_plan_task_spec.rb | 320 +-
 5 files changed, 583 insertions(+), 22 deletions(-)

Comment 8 CFME Bot 2018-10-11 14:27:48 UTC
New commit detected on ManageIQ/manageiq-gems-pending/hammer:

https://github.com/ManageIQ/manageiq-gems-pending/commit/1ee45ac9278b5b758bbce9271136f80c597532b4
commit 1ee45ac9278b5b758bbce9271136f80c597532b4
Author:     Nick Carboni <ncarboni@redhat.com>
AuthorDate: Wed Oct 10 09:41:47 2018 -0400
Commit:     Nick Carboni <ncarboni@redhat.com>
CommitDate: Wed Oct 10 09:41:47 2018 -0400

    Merge pull request #382 from fdupont-redhat/add_stdin_to_shell_exec

    Add stdin option to shell_exec

    (cherry picked from commit 4442396b4f7271f1402a78b2164da450f4b4e6cd)

    https://bugzilla.redhat.com/show_bug.cgi?id=1634029

 lib/gems/pending/util/MiqSshUtil.rb | 6 +-
 1 file changed, 3 insertions(+), 3 deletions(-)

Comment 14 Fabien Dupont 2018-10-12 14:43:16 UTC
https://github.com/ManageIQ/manageiq/pull/18064

Comment 16 CFME Bot 2018-10-12 16:23:06 UTC
New commit detected on ManageIQ/manageiq/hammer:

https://github.com/ManageIQ/manageiq/commit/9a1c355ae8a39dcabf75d06c00e06e8dca861cfc
commit 9a1c355ae8a39dcabf75d06c00e06e8dca861cfc
Author:     Adam Grare <agrare@redhat.com>
AuthorDate: Thu Oct 11 14:42:17 2018 -0400
Commit:     Adam Grare <agrare@redhat.com>
CommitDate: Thu Oct 11 14:42:17 2018 -0400

    Merge pull request #18064 from fdupont-redhat/conversion_host_backport_from_automate_pt2

    Backport methods from Automate to conversion_host - part2

    (cherry picked from commit 7d140f55d6856d35151f94c8f42ead287a227c22)

    https://bugzilla.redhat.com/show_bug.cgi?id=1634029

 app/models/conversion_host.rb | 144 +-
 app/models/service_template_transformation_plan_task.rb | 95 +-
 spec/models/conversion_host_spec.rb | 106 +-
 spec/models/service_template_transformation_plan_task_spec.rb | 186 +-
 4 files changed, 458 insertions(+), 73 deletions(-)

Comment 17 CFME Bot 2018-10-12 19:00:57 UTC
New commits detected on ManageIQ/manageiq-automation_engine/hammer:

https://github.com/ManageIQ/manageiq-automation_engine/commit/cdf3021c43292acf1025b54e2f16136ddbf767cb
commit cdf3021c43292acf1025b54e2f16136ddbf767cb
Author:     Madhu Kanoor <mkanoor@redhat.com>
AuthorDate: Fri Oct 12 09:05:35 2018 -0400
Commit:     Madhu Kanoor <mkanoor@redhat.com>
CommitDate: Fri Oct 12 09:05:35 2018 -0400

    Merge pull request #246 from fdupont-redhat/v2v_expose_task_methods_1

    Expose ConversionHost and ServiceTemplateTransformationPlanTask methods

    (cherry picked from commit 11925fb804325aa089ca74c0369e89fe66760c30)

    https://bugzilla.redhat.com/show_bug.cgi?id=1634029

 lib/miq_automation_engine/service_models/miq_ae_service_conversion_host.rb | 9 +
 lib/miq_automation_engine/service_models/miq_ae_service_service_template_transformation_plan_task.rb | 15 +
 2 files changed, 24 insertions(+)


https://github.com/ManageIQ/manageiq-automation_engine/commit/f829b52155ea22bbfd4b3135bd06da87f726b7bb
commit f829b52155ea22bbfd4b3135bd06da87f726b7bb
Author:     Greg McCullough <gmccullo@redhat.com>
AuthorDate: Fri Oct 12 10:12:12 2018 -0400
Commit:     Greg McCullough <gmccullo@redhat.com>
CommitDate: Fri Oct 12 10:12:12 2018 -0400

    Merge pull request #252 from fdupont-redhat/fix_conversion_host_service_model

    Fix class name for conversion host

    (cherry picked from commit 30e762f27fbaacb56a1e3b3caa8806c5079aa786)

    https://bugzilla.redhat.com/show_bug.cgi?id=1634029

 lib/miq_automation_engine/service_models/miq_ae_service_conversion_host.rb | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

Comment 18 Fabien Dupont 2018-10-15 19:23:55 UTC
https://github.com/ManageIQ/manageiq/pull/18097

Comment 20 CFME Bot 2018-10-16 13:15:43 UTC
New commit detected on ManageIQ/manageiq/hammer:

https://github.com/ManageIQ/manageiq/commit/fe677b4829b43c2bb863967f03f93f9a81f20555
commit fe677b4829b43c2bb863967f03f93f9a81f20555
Author:     Adam Grare <agrare@redhat.com>
AuthorDate: Mon Oct 15 15:43:54 2018 -0400
Commit:     Adam Grare <agrare@redhat.com>
CommitDate: Mon Oct 15 15:43:54 2018 -0400

    Merge pull request #18097 from fdupont-redhat/conversion_host_ems

    Add ext_management_system method to conversion host

    (cherry picked from commit 8bc00490381b6b84fb4f65d3b6577924d576b5fd)

    https://bugzilla.redhat.com/show_bug.cgi?id=1634029

 app/models/conversion_host.rb | 1 +
 1 file changed, 1 insertion(+)

Comment 21 CFME Bot 2018-10-16 13:17:24 UTC
New commit detected on ManageIQ/manageiq-automation_engine/hammer:

https://github.com/ManageIQ/manageiq-automation_engine/commit/53d96c406e792647e789c01550e37d63d805f293
commit 53d96c406e792647e789c01550e37d63d805f293
Author:     Greg McCullough <gmccullo@redhat.com>
AuthorDate: Mon Oct 15 16:21:59 2018 -0400
Commit:     Greg McCullough <gmccullo@redhat.com>
CommitDate: Mon Oct 15 16:21:59 2018 -0400

    Merge pull request #255 from fdupont-redhat/conversion_host_ems

    Expose ext_management_system from ConversionHost

    (cherry picked from commit 4c9638e068c4447de93cb001cbd439ed8f17796a)

    https://bugzilla.redhat.com/show_bug.cgi?id=1634029

 lib/miq_automation_engine/service_models/miq_ae_service_conversion_host.rb | 1 +
 1 file changed, 1 insertion(+)

Comment 22 CFME Bot 2018-10-17 13:37:23 UTC
New commit detected on ManageIQ/manageiq-automation_engine/hammer:

https://github.com/ManageIQ/manageiq-automation_engine/commit/736eba51486c296d95eaf7b5294e4335675f690a
commit 736eba51486c296d95eaf7b5294e4335675f690a
Author:     Greg McCullough <gmccullo@redhat.com>
AuthorDate: Wed Oct 17 08:36:16 2018 -0400
Commit:     Greg McCullough <gmccullo@redhat.com>
CommitDate: Wed Oct 17 08:36:16 2018 -0400

    Merge pull request #253 from fdupont-redhat/add_conversion_host_method

    Add conversion_host= method to MiqAeServiceServiceTemplateTransformationPlanTask

    (cherry picked from commit e2329f72fea82c4440189baa223d2bb30bf04f8b)

    https://bugzilla.redhat.com/show_bug.cgi?id=1634029

 lib/miq_automation_engine/service_models/miq_ae_service_service_template_transformation_plan_task.rb | 9 +
 spec/service_models/miq_ae_service_service_template_transformation_plan_task_spec.rb | 19 +
 2 files changed, 28 insertions(+)

Comment 23 Fabien Dupont 2018-10-17 13:40:51 UTC
https://github.com/ManageIQ/manageiq/pull/18101

Comment 24 Fabien Dupont 2018-10-17 13:41:09 UTC
https://github.com/ManageIQ/manageiq/pull/18103

Comment 25 CFME Bot 2018-10-18 13:30:50 UTC
New commit detected on ManageIQ/manageiq/hammer:

https://github.com/ManageIQ/manageiq/commit/84a10456ba1270d7a10b91dc607738bd438ac09a
commit 84a10456ba1270d7a10b91dc607738bd438ac09a
Author:     Adam Grare <agrare@redhat.com>
AuthorDate: Wed Oct 17 17:12:03 2018 -0400
Commit:     Adam Grare <agrare@redhat.com>
CommitDate: Wed Oct 17 17:12:03 2018 -0400

    Merge pull request #18103 from fdupont-redhat/conversion_host_hostname_as_ipaddress

    Conversion Host - Try hostname for SSH and fix MiqSshUtil args

    (cherry picked from commit 84a80a0401d7cfce7e9674ee8ba78da5e3482661)

    https://bugzilla.redhat.com/show_bug.cgi?id=1634029

 app/models/conversion_host.rb | 10 +-
 1 file changed, 6 insertions(+), 4 deletions(-)

Comment 26 CFME Bot 2018-10-18 21:55:55 UTC
New commit detected on ManageIQ/manageiq/hammer:

https://github.com/ManageIQ/manageiq/commit/6cadbd875be7859255b1f33f1458c6500265b767
commit 6cadbd875be7859255b1f33f1458c6500265b767
Author:     Adam Grare <agrare@redhat.com>
AuthorDate: Thu Oct 18 13:05:28 2018 -0400
Commit:     Adam Grare <agrare@redhat.com>
CommitDate: Thu Oct 18 13:05:28 2018 -0400

    Merge pull request #18101 from fdupont-redhat/conversion_host_ems_ref

    Add resource ems_ref and ip addresses to virt-v2v options hash

    (cherry picked from commit 88f7d2fa570422b657c7f6aa2fcb0c41a527f378)

    https://bugzilla.redhat.com/show_bug.cgi?id=1634029

 app/models/conversion_host.rb | 3 +-
 app/models/service_template_transformation_plan_task.rb | 19 +-
 spec/models/service_template_transformation_plan_task_spec.rb | 46 +-
 3 files changed, 38 insertions(+), 30 deletions(-)

Comment 27 CFME Bot 2018-10-19 20:31:37 UTC
New commit detected on ManageIQ/manageiq-content/hammer:

https://github.com/ManageIQ/manageiq-content/commit/2faee2798f779cd04ce293819ccd8f15ab0b4e2e
commit 2faee2798f779cd04ce293819ccd8f15ab0b4e2e
Author:     tina <tina.fitzgerald2@gmail.com>
AuthorDate: Fri Oct 19 13:47:29 2018 -0400
Commit:     tina <tina.fitzgerald2@gmail.com>
CommitDate: Fri Oct 19 13:47:29 2018 -0400

    Merge pull request #441 from fdupont-redhat/v2v_move_code_to_backend_1

    Refactor to delegate task and conversion host code to backend

    (cherry picked from commit 8e7ed4dd5d1faf5ce132b0f7a20af4c1265c0cc5)

    https://bugzilla.redhat.com/show_bug.cgi?id=1634029

 content/automate/ManageIQ/Transformation/Common.class/__methods__/acquiretransformationhost.rb | 2 +-
 content/automate/ManageIQ/Transformation/Common.class/__methods__/assesstransformation.rb | 68 +-
 content/automate/ManageIQ/Transformation/Common.class/__methods__/killvirtv2v.rb | 39 +
 content/automate/ManageIQ/Transformation/Common.class/__methods__/killvirtv2v.yaml | 15 +
 content/automate/ManageIQ/Transformation/Common.class/__methods__/setmigrated.rb | 23 +
 content/automate/ManageIQ/Transformation/Common.class/__methods__/setmigrated.yaml | 15 +
 content/automate/ManageIQ/Transformation/Common.class/__methods__/vmchecktransformed.rb | 56 +
 content/automate/ManageIQ/Transformation/Common.class/__methods__/vmchecktransformed.yaml | 15 +
 content/automate/ManageIQ/Transformation/Common.class/__methods__/vmtransform.rb | 27 +
 content/automate/ManageIQ/Transformation/Common.class/__methods__/vmtransform.yaml | 15 +
 content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/checkpoweredon.rb | 22 +-
 content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/checkpoweredon.yaml | 2 +
 content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/checkvmininventory.rb | 38 +-
 content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/checkvmininventory.yaml | 2 +
 content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/collapsesnapshots.rb | 31 +
 content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/collapsesnapshots.yaml | 15 +
 content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/poweroff.rb | 24 +-
 content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/poweroff.yaml | 2 +
 content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/poweron.rb | 19 +-
 content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/poweron.yaml | 2 +
 content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/restorevmattributes.rb | 69 +-
 content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/restorevmattributes.yaml | 2 +
 content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/setdescription.rb | 30 +
 content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/setdescription.yaml | 16 +
 content/automate/ManageIQ/Transformation/Infrastructure/VM/rhevm.class/__methods__/setdescription.rb | 31 -
 content/automate/ManageIQ/Transformation/Infrastructure/VM/rhevm.class/__methods__/setdescription.yaml | 15 -
 content/automate/ManageIQ/Transformation/Infrastructure/VM/rhevm.class/__methods__/utils.rb | 107 +-
 content/automate/ManageIQ/Transformation/Infrastructure/VM/vmwarews.class/__class__.yaml | 33 -
 content/automate/ManageIQ/Transformation/Infrastructure/VM/vmwarews.class/__methods__/collapsesnapshots.rb | 37 -
 content/automate/ManageIQ/Transformation/Infrastructure/VM/vmwarews.class/__methods__/collapsesnapshots.yaml | 15 -
 content/automate/ManageIQ/Transformation/Infrastructure/VM/vmwarews.class/__methods__/setmigrated.rb | 55 -
 content/automate/ManageIQ/Transformation/Infrastructure/VM/vmwarews.class/__methods__/setmigrated.yaml | 15 -
 content/automate/ManageIQ/Transformation/Infrastructure/VM/vmwarews.class/__methods__/utils.rb | 30 -
 content/automate/ManageIQ/Transformation/Infrastructure/VM/vmwarews.class/__methods__/utils.yaml | 13 -
 content/automate/ManageIQ/Transformation/Infrastructure/VM/vmwarews.class/_missing.yaml | 12 -
 content/automate/ManageIQ/Transformation/StateMachines/VMTransformation.class/posttransform.yaml | 4 +-
 content/automate/ManageIQ/Transformation/StateMachines/VMTransformation.class/pretransform.yaml | 2 +-
 content/automate/ManageIQ/Transformation/StateMachines/VMTransformation.class/transform.yaml | 4 +-
 content/automate/ManageIQ/Transformation/StateMachines/VMTransformation.class/transformationcleanup.yaml | 2 +-
 content/automate/ManageIQ/Transformation/TransformationHosts/Common.class/__class__.yaml | 33 -
 content/automate/ManageIQ/Transformation/TransformationHosts/Common.class/__methods__/killvirtv2v.rb | 37 -
 content/automate/ManageIQ/Transformation/TransformationHosts/Common.class/__methods__/killvirtv2v.yaml | 16 -
 content/automate/ManageIQ/Transformation/TransformationHosts/Common.class/__methods__/utils.rb | 163 -
 content/automate/ManageIQ/Transformation/TransformationHosts/Common.class/__methods__/utils.yaml | 16 -
 content/automate/ManageIQ/Transformation/TransformationHosts/Common.class/__methods__/vmchecktransformed.rb | 81 -
 content/automate/ManageIQ/Transformation/TransformationHosts/Common.class/__methods__/vmchecktransformed.yaml | 16 -
 content/automate/ManageIQ/Transformation/TransformationHosts/Common.class/__methods__/vmtransform.rb | 56 -
 content/automate/ManageIQ/Transformation/TransformationHosts/Common.class/__methods__/vmtransform.yaml | 17 -
 content/automate/ManageIQ/Transformation/TransformationHosts/Common.class/_missing.yaml | 12 -
 content/automate/ManageIQ/Transformation/TransformationHosts/ovirt_host.class/__methods__/utils.rb | 77 -
 content/automate/ManageIQ/Transformation/TransformationHosts/ovirt_host.class/__methods__/utils.yaml | 13 -
 content/automate/ManageIQ/Transformation/TransformationThrottler.class/__methods__/throttle.yaml | 1 -
 content/automate/ManageIQ/Transformation/TransformationThrottler.class/__methods__/utils.rb | 51 +-
 content/automate/ManageIQ/Transformation/TransformationThrottler.class/__methods__/utils.yaml | 2 -
 spec/content/automate/ManageIQ/Transformation/Common.class/__methods__/acquiretransformationhost_spec.rb | 10 +-
 spec/content/automate/ManageIQ/Transformation/Common.class/__methods__/assesstransformation_spec.rb | 330 +-
 spec/content/automate/ManageIQ/Transformation/Common.class/__methods__/killvirtv2v_spec.rb | 109 +
 spec/content/automate/ManageIQ/Transformation/Common.class/__methods__/setmigrated_spec.rb | 50 +
 spec/content/automate/ManageIQ/Transformation/Common.class/__methods__/vmchecktransformed_spec.rb | 95 +
 spec/content/automate/ManageIQ/Transformation/Common.class/__methods__/vmtransform_spec.rb | 45 +
 spec/content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/checkpoweredon_spec.rb | 68 +
 spec/content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/checkvmininventory_spec.rb | 111 +-
 spec/content/automate/ManageIQ/Transformation/Infrastructure/VM/Common.class/__methods__/restorevmattributes_spec.rb | 107 +-
 spec/content/automate/ManageIQ/Transformation/TransformationHosts/Common.class/__methods__/utils_spec.rb | 314 -
 spec/content/automate/ManageIQ/Transformation/TransformationThrottler.class/__methods__/utils_spec.rb | 209 +-
 65 files changed, 1139 insertions(+), 1824 deletions(-)

Comment 32 errata-xmlrpc 2019-02-07 23:03:43 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2019:0212


Note You need to log in before you can comment on or make changes to this bug.